<template>
    <div class="text-center">
    <v-dialog v-model="dialog" max-width="600">
      <template v-slot:activator="{ on, attrs }">
        <v-btn
          small
          color="primary"
          v-bind="attrs"
          v-on="on"
          class="ma-5"
        >
          Invite to your group
        </v-btn>
      </template>
      <v-card>
        <v-container>
          <v-card-text>
            <p class="title">Enter participants details below</p>
            <span>The participant will receive invite email</span>
            <v-form ref="form" v-model="valid">
              <v-row>
                <v-col>
                  <v-text-field outlined v-model="firstName" placeholder="First Name"/>
                </v-col>
                <v-col>
                  <v-text-field outlined v-model="email" placeholder="Email" :rules="rulesEmail"/>
                </v-col>
              </v-row>
              <v-btn outlined class="text-right" :disabled="!firstName || !email" @click="sendInvite">Send Invite</v-btn>
            </v-form>
          </v-card-text>
        </v-container>
      </v-card>
    </v-dialog>
  </div>

</template>

<script>
export default {
    name: 'Participants',
    props: {
        participants: {
            type: Object
        }
    },
    data: () => ({
        dialog: false,
        firstName: null,
        email: null,
        rulesEmail: [
          value => !!value || 'Required.',
          value => (value && value.length >= 3) || 'Min 3 characters',
          value => {
            const pattern = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
            return pattern.test(value) || 'Invalid e-mail.'
          }
        ],
        valid: false
    }),
    beforeDestroy() {
      this.email = null
      this.firstName = null
    },
    methods: {
      sendInvite() {
        if (this.$refs.form.validate()) {
          this.dialog = false
          this.$store.dispatch('group/sendGroupInvite', {firstName: this.firstName, email: this.email})
        }
      }
    }

}
</script>
